#include <stdlib.mqh>

//| Default Wait for 20 point.                                       |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " andrew"
#property link      ""


//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

extern int MagicNumber = 0;
extern double Lots = 1.00;
extern double StopLoss = 20.00;
extern double TakeProfit = 20.00;
extern double TrailingStop = 15.00;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double Slippage = 5;
extern double Limit = 500;
extern double FastPeriod = 5;
extern double SlowPeriod = 20;
extern double wait = 20;
extern double spread = 2;
extern int PipsForBounce= 3;



//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;

bool MOrderModify( int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderModify( ticket, price, stoploss, takeprofit, expiration, arrow_color) );
}

int MOrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderSend( symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, expiration, arrow_color ) );
}

int OrderValueTicket(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTicket());
}

int OrderValueType(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderType());
}

double OrderValueLots(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderLots());
}

double OrderValueOpenPrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderOpenPrice());
}

double OrderValueStopLoss(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderStopLoss());
}

double OrderValueTakeProfit(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTakeProfit());
}

string OrderValueSymbol(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderSymbol());
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
double iMaSlow1 = 0;
double iMaSlow2 = 0;
double iMaSlow0 = 0;
double iMaFast1 = 0;
double iMaFast2 = 0;
double iMAFast0 = 0;
double diff0 = 0;
double diff1 = 0;
double diff2 = 0;

double crossupval = 0;
double crossdownval = 0;
double waitupval = 0;
double waitdownval = 0;
bool bounceup = False;
bool bouncedown = False;
bool crossup = False;
bool crossdown = False;


 /*[[
	Name := BG Cross v2b6_ATR_dpo
	Author := hapsa
	Notes := BunnyGirl's Cross of Moneytec
	Notes := 5-20 WMA at 30 min with ATR Trailing Stop of OlegVS
	Notes := Default Wait for 20 point.
	Lots := 1.00
	Stop Loss := 0
	Take Profit := 100
	Trailing Stop := 30
]]*/



//EMA Parameters------------------------------------------	
iMaSlow2 = iMA(NULL, 0, SlowPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  2);
iMaSlow1 = iMA(NULL, 0, SlowPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  1);
iMaSlow0 = iMA(NULL, 0, SlowPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  0);
iMaFast2 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  2);
iMaFast1 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  1);
iMAFast0 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  0);

diff0 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  0) - iMaSlow0;
diff1 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  1) - iMaSlow1;
diff2 = iMA(NULL, 0, FastPeriod,  0,  MODE_EMA,  PRICE_CLOSE,  2) - iMaSlow2;

//--------------------------------------------------------



//Reset---------------------------------------------------
if( OrdersTotal() >= 1 ) {
	crossup=False;
	crossdown=False;
	bounceup=false;
	bouncedown=false;
	waitupval=0;
	waitdownval=0;
	crossdownval=0;
	crossupval=0;
}	 



//EMA Cross Setup ----------------------------------------       
if( OrdersTotal()<1 ) 
if( (iMaFast1<iMaSlow1 && iMAFast0>iMaSlow0) && (iMaFast2<iMaSlow2 && iMAFast0>iMaSlow0) ) 
	{
	crossup = True;
	crossdown = False;
	bounceup=false;
	bouncedown=false;
	crossupval = iMaSlow1;
	crossdownval = 0;
	waitupval = crossupval+(wait+spread)*Point;
	waitdownval = crossupval-wait*Point;
	}
	
if( ((iMaFast1>iMaSlow1) && iMAFast0<iMaSlow0) && (iMaFast2>iMaSlow2 && iMAFast0<iMaSlow0) ) 
	{
	crossdown = True;
	crossup = False;
	bounceup=false;
	bouncedown=false;
	crossdownval = iMaSlow1;
	crossupval = 0;
	waitupval = crossdownval+(wait+spread)*Point;
	waitdownval = crossdownval-wait*Point;
	}

if ((iMaFast1>iMaSlow1) && (diff2>diff1) && (diff0>=diff1)&& (diff1 <= PipsForBounce*Point) )
{
	bounceup = True;
	bouncedown=false;
	crossdown = false;
	crossup = False;
	crossupval = iMaSlow1;
	crossdownval = 0;
	waitupval = crossupval+(wait+spread)*Point;
	waitdownval = crossupval-wait*Point;
	}

if ((iMaFast1<iMaSlow1) && (diff2<diff1) && (diff0<=diff1)&&(MathAbs(diff1) <= PipsForBounce*Point) )
{
	
	bouncedown=True;
	bounceup = false;
	crossdown = false;
	crossup = False;
	crossupval = iMaSlow2;
	crossdownval = 0;
	waitupval = crossupval+(wait+spread)*Point;
	waitdownval = crossupval-wait*Point;
	}




//The BG Cross Entry Rules---------------------------------	
  if( OrdersTotal()<1 ) 
  {
	if( AccountFreeMargin()<Limit ) return(0);
	
	if( crossup ==  true && Ask>=waitupval  && waitdownval != 0 && waitupval != 0 ) 
	{
		Print( "Cross Long Entry at ", Ask );
		MOrderSend(Symbol(),OP_BUY,1,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MagicNumber,0,Blue);
	}
    
    if( crossdown == True && Bid<=waitdownval  && waitdownval != 0 && waitupval != 0 ) 
	{
		Print( "Cross Short Entry at ", Bid );
		MOrderSend(Symbol(),OP_SELL,1,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MagicNumber,0,Red);	 		
	}
	
	if( bouncedown == True && Bid<=waitdownval  && waitdownval != 0 && waitupval != 0 ) 
	{
		Print( "Bounce Short Entry at ", Bid );
		MOrderSend(Symbol(),OP_SELL,1,Bid,Slippage,Bid-StopLoss*Point,Bid-TakeProfit*Point,"",MagicNumber,0,Red);	 		
	}
	
	if( bounceup == True && Ask>=waitupval && waitdownval != 0 && waitupval != 0 ) 
	{
		Print( "Bounce Long Entry at ", Ask );
		MOrderSend(Symbol(),OP_BUY,1,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MagicNumber,0,Blue);
	}	
	return(0);
  }


}

